<?php
	/**
	* @ Author www.softiran.org
	* @ Copyright 2016
	*/
	# Required File Includes
	if(file_exists("../../../dbconnect.php"))
	{
		include("../../../dbconnect.php");
	}else
	{
		include("../../../init.php");
	}
	include("../../../includes/functions.php");
	include("../../../includes/gatewayfunctions.php");
	include("../../../includes/invoicefunctions.php");


	$gatewaymodule = "mabna"; # Enter your gateway module name here replacing template
	$GATEWAY = getGatewayVariables($gatewaymodule);

	if (!$GATEWAY["type"]) die("Module Not Activated"); # Checks gateway module is active before accepting callback
	# Get Returned Variables - Adjust for Post Variable Names from your Gateway's Documentation
	$invoiceNumber = $_GET['invoiceid'];
	
	$referenceId = $_POST['TRN'];

	$invoiceNumber = checkCbInvoiceID($invoiceNumber,$GATEWAY["name"]); # Checks invoice ID is a valid invoice number or ends processing
	$results = select_query( "tblinvoices", "", array( "id" => $invoiceNumber ) );
	$data = mysql_fetch_array( $results );
	$db_amount = strtok($data['total'],'.');
	
	if( isset($_POST['CRN']) && isset($_POST['TRN']) && isset($_POST['RESCODE']) && $_POST['RESCODE'] == '00' )
	{
		checkCbTransID($referenceId); # Checks transaction number isn't already in the database and ends processing if it does
		$MerchantId = trim($GATEWAY['MerchantId']);
		$Currencies = trim($GATEWAY['Currencies']);
		if($Currencies != 'Rial')
			$db_amount = $db_amount * 10;
		
		$merchant = trim($GATEWAY['MerchantId']);
		$pat = dirname(__FILE__);
		if(!function_exists('timestamp_to_iso8601'))
		{
			include_once($pat . '/../../../includes/nusoap2.php');
		}
		$client = new nusoap_client("https://mabna.shaparak.ir/TransactionReference/TransactionReference?wsdl", 'wsdl');
		$error = $client->getError();
		
		$fp = fopen($pat . '/../../../public.txt', "r");
		$pub_key = fread($fp, 8192);
		fclose($fp);
		if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
			$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

		if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
			$pub_key .= "\n-----END PUBLIC KEY-----";

		$key_resource = openssl_get_publickey($pub_key);

		openssl_public_encrypt($_POST["TRN"], $crypttext, $key_resource );
		$TRN = base64_encode($crypttext);

		// CRN
		openssl_public_encrypt($_POST["CRN"], $crypttext, $key_resource );
		$CRN = base64_encode($crypttext);

		// MID
		openssl_public_encrypt($merchant, $crypttext, $key_resource );
		$MID = base64_encode($crypttext);

		// Sign data
		$source = $merchant.$_POST["TRN"].$_POST["CRN"];
		
		$key = file_get_contents($pat . '/../../../private.txt');

		if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
			$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

		if (strpos($key, '-----END PRIVATE KEY-----') === false)
			$key .= "\n-----END PRIVATE KEY-----";

		$priv_key = openssl_pkey_get_private($key);
		$signature = '';
		openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
		$inputArray = array("SaleConf_req" => array("MID"    => $MID,
													"CRN"    => $CRN,
													"TRN"    => $TRN,
													"SIGNATURE" => base64_encode($signature)));
		$WSResult = $client->call("sendConfirmation", $inputArray);
		$error = $client->getError();
		$signature = base64_decode($WSResult["return"]["SIGNATURE"]);
		$data      = $WSResult["return"]["RESCODE"].$WSResult["return"]["REPETETIVE"].$WSResult["return"]["AMOUNT"].$WSResult["return"]["DATE"].$WSResult["return"]["TIME"].$WSResult["return"]["TRN"].$WSResult["return"]["STAN"];
		$ok = openssl_verify($data, $signature, $key_resource);
		if ($ok == 1) 
		{
			 if (($WSResult['return']['RESCODE'] == '00') && ($WSResult['return']['successful'] == true)) 
			 {
				if( floatval($WSResult["return"]["AMOUNT"]) == floatval($db_amount) )
				{
					$transid = $WSResult["return"]["TRN"];
					 $fee = 0;
					 if($Currencies != 'Rial')
						$db_amount = $db_amount / 10;
					addInvoicePayment($invoiceNumber,$transid,$db_amount,$fee,$gatewaymodule); # Apply Payment to Invoice: invoiceid,  transactionid, amount paid, fees, modulename
					logTransaction($gatewaymodule,$_POST,"Successful"); # Save to Gateway Log: name, data array, status
					$url = $CONFIG['SystemURL'].'/viewinvoice.php?id='.$invoiceNumber;
					Header('Location: '.$CONFIG['SystemURL'].'/viewinvoice.php?id='.$invoiceNumber);
					die("<script>window.location='$url';</script>");
				}else
				{
					$resultCode = 'مبلغ واریز و مبلغ سفارش برابر نیست';
				}
			 }else
			 {
				 $resultCode = 'سفارش قبلا پرداخت شده است';
			 }
		}else
		{
			$resultCode = 'خطا در وریفای اطلاعات';
		}
	}else
	{
		$resultCode = 'برگشت ناموفق از درگاه';
	}
	logTransaction($gatewaymodule,($resultCode),"Unsuccessful"); # Save to Gateway Log: name, data array, status
	$url = $CONFIG['SystemURL'].'/viewinvoice.php?id='.$invoiceNumber;
	Header('Location: '.$CONFIG['SystemURL'].'/viewinvoice.php?id='.$invoiceNumber);
	die("<script>window.location='$url';</script>");
	 
?>