<?php
/**
     * @ Author www.softiran.org
     * @ Copyright 2016
     */

function mabna_config() {
	$configarray = array(
	"FriendlyName" => array("Type" => "System", "Value"=>"پرداخت توسط درگاه شرکت مبنا کارت"),
	"MerchantId" => array("FriendlyName" => "MerchantId", "Type" => "text", "Size" => "50", ),
	"Terminal" => array("FriendlyName" => "Terminal", "Type" => "text", "Size" => "50", ),
	"Currencies" => array("FriendlyName" => "Currencies", "Type" => "dropdown", "Options" => "Rial,Toman", ),
	);
	return $configarray;
}

function mabna_link($params) {

	# Gateway Specific Variables
	$merchant = $params['MerchantId'];
	$terminal = $params['Terminal'];

	$invoiceid = $params['invoiceid'];
	$description = $params["description"];
    $amount = $params['amount']; # Format: ##.##
	$amount=strtok($amount,'.');
	if($params['Currencies'] != 'Rial')
		$amount = $amount * 10;

	$firstname = $params['clientdetails']['firstname'];
	$lastname = $params['clientdetails']['lastname'];
	$email = $params['clientdetails']['email'];
	$address1 = $params['clientdetails']['address1'];
	$address2 = $params['clientdetails']['address2'];
	$city = $params['clientdetails']['city'];
	$state = $params['clientdetails']['state'];
	$postcode = $params['clientdetails']['postcode'];
	$country = $params['clientdetails']['country'];
	$phone = $params['clientdetails']['phonenumber'];

	# System Variables
	$companyname = $params['companyname'];
	$systemurl = $params['systemurl'];
	$redirectAddress = ($params['systemurl'].'/modules/gateways/callback/mabna.php?invoiceid='.$invoiceid);
	$pat = dirname(__FILE__);
	
	if(!function_exists('timestamp_to_iso8601'))
	{
		include_once($pat . '/../../includes/nusoap2.php');
	}
	$invoiceNumber = time();
	$source = $amount . $invoiceNumber . $merchant . $redirectAddress . $terminal;

    $fp = fopen($pat . '/../../public.txt', "r");
    $pub_key = fread($fp, 8192);
    fclose($fp);
    if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
        $pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

    if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
        $pub_key .= "\n-----END PUBLIC KEY-----";


    // Amount
    $key_resource = openssl_get_publickey($pub_key);

    openssl_public_encrypt($amount, $crypttext, $key_resource);

    $Amount = base64_encode($crypttext);
    // CRN

    openssl_public_encrypt($invoiceNumber, $crypttext, $key_resource);
    $CRN = base64_encode($crypttext);

    // MID
    openssl_public_encrypt($merchant, $crypttext, $key_resource);
    $MID = base64_encode($crypttext);

    // TID
    openssl_public_encrypt($terminal, $crypttext, $key_resource);
    $TID = base64_encode($crypttext);

    // redirectAddress
    openssl_public_encrypt($redirectAddress, $crypttext, $key_resource);
    $referal = base64_encode($crypttext);

    $key = file_get_contents($pat . '/../../private.txt');

    if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
        $key = "-----BEGIN PRIVATE KEY-----\n" . $key;

    if (strpos($key, '-----END PRIVATE KEY-----') === false)
        $key .= "\n-----END PRIVATE KEY-----";

    $priv_key = openssl_pkey_get_private($key);
    $signature = '';
    openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
    $inputArray = array("Token_param" => array("AMOUNT" => $Amount,
        "CRN" => $CRN,
        "MID" => $MID,
        "REFERALADRESS" => $referal,
        "SIGNATURE" => base64_encode($signature),
        "TID" => $TID,
    ));

    $__SOAP = "https://mabna.shaparak.ir/TokenService?wsdl";
    $client = new nusoap_client($__SOAP, 'wsdl');
    $WSResult = $client->call("reservation", $inputArray);
    $signature = base64_decode($WSResult['return']['signature']);
    $ok = openssl_verify($WSResult['return']['token'], $signature, $key_resource);
    openssl_free_key($key_resource);
	
    if ($ok == 1 && $WSResult['return']['result'] == 0)
	{
		$code = '
	<form method="post" action="https://mabna.shaparak.ir">
	<input type="hidden" name="TOKEN" value="'.$WSResult['return']['token'].'" />
	<input type="submit" name="pay" value="برای پرداخت صورتحساب کلیک کنید" />
	</form>';

		return $code;
	}else
	{
		return '<p>خطا در ساخت توکن : </p>'.$WSResult['return']['token'];
	}
}
?>